https://leetcode.com/problems/find-and-replace-pattern/
Given a list of strings words and a string pattern, return a list of words[i] that match pattern. You may return the answer in any order. A word matches the pattern if there exists a permutation of letters p so that after replacing every letter x in the pattern with p(x), we get the desired word. Recall that a permutation of letters is a bijection from letters to letters: every letter maps to another letter, and no two letters map to the same letter.
Example 1: Input: words = [“abc”,“deq”,“mee”,“aqq”,“dkd”,“ccc”], pattern = “abb” Output: [“mee”,“aqq”] Explanation: “mee” matches the pattern because there is a permutation {a -> m, b -> e, …}. “ccc” does not match the pattern because {a -> c, b -> c, …} is not a permutation, since a and b map to the same letter. Example 2: Input: words = [“a”,“b”,“c”], pattern = “a” Output: [“a”,“b”,“c”]
Constraints:
1 <= pattern.length <= 20
1 <= words.length <= 50
words[i].length == pattern.length
pattern and words[i] are lowercase English letters.
- code
class Solution {
public List<String> findAndReplacePattern(String[] words, String pattern) {
return Arrays.stream(words).filter(w -> match(w, pattern)).collect(Collectors.toList());
}
private boolean match(String w1, String w2){
if (w1.length() != w2.length()) return false;
Map<Character, Character> m = new HashMap<>();
Set<Character> seen = new HashSet<>();
for (int i = 0; i < w1.length(); i++){
char c1 = w1.charAt(i);
char c2 = w2.charAt(i);
if (m.containsKey(c1) && m.get(c1) != c2) return false;
else m.put(c1, c2);
}
for (char c: m.values()){
if (seen.contains(c)) return false;
seen.add(c);
}
return true;
}
}